<!doctype html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport"
          content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Document</title>
</head>
<body>
<div>
    <div>
        <label for="name">Name:</label>
        <input type="text" id="name" name="name" required>
    </div>
    <div>
        <label for="lastName">Lastname:</label>
        <input type="text" id="lastName" name="lastName" required>
    </div>
    <div>
        <label for="dayOfBirth">Day of birth</label>
        <input type="date" id="dayOfBirth" name="dayOfBirth" required>
    </div>
    <button id="addPerson" type="submit">Add Person</button>
</div>

<hr/>
<button type="button" id="getPersons">get all persons</button>
<div id="root" style="display:flex; gap: 10px; flex-wrap: wrap"></div>

</body>

<script>
    let dayOfBirth = 649966698;
    document.getElementById("dayOfBirth").addEventListener("change", (e) => {
        dayOfBirth = (new Date(e.target.value).getTime() / 1000).toFixed(0)
    })

    document.getElementById("addPerson").addEventListener("click", (e) => {
        e.preventDefault()
        const o = {
            name: "Volodymyr",
            lastName: "Vlasov",
            dayOfBirth: dayOfBirth
        }

        let request = new Request("http://localhost:8080/persons", {
            method: 'POST',
            body: JSON.stringify(o),
            headers: {'Content-Type': 'application/json'}
        })

        fetch(request)
            .then(data => data.json())
            .then(data => console.log(data))
            .catch(error => console.log(error))

        renderPersons()
    })

    document.getElementById("getPersons").addEventListener("click", renderPersons())

    function renderPersons() {
        fetch("http://localhost:8080/persons")
            .then(data => data.json())
            .then(data => {
                const cnt = document.getElementById("root")
                cnt.innerHTML = ""

                data.forEach(person => {
                    console.log(person)
                    cnt.innerHTML += `
                        <div style="padding: 10px; border: 1px solid">
                            <p>${person.name} ${person.lastName}</p>
                            <p>age: ${person["age"]}</p>
                            <p>day of birth: ${new Date(person["dayOfBirth"]).toLocaleDateString()}</p>
                            <button onclick="deleteById(${person.id})">Delete</button>
                        </div>
                `
                })
            })
    }

    function deleteById(id) {
        let request = new Request(`http://localhost:8080/persons/${id}`, {
            method: 'DELETE'
        })
        fetch(request)
            .then(data => renderPersons())
            .catch(err => console.log(err))
    }
</script>
</html>